unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SQLite3Conn, SQLDB, DB, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, DBGrids, StdCtrls, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBGrid3: TDBGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLQuery2: TSQLQuery;
    SQLQuery3: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SQLQuery3BeforeOpen(DataSet: TDataSet);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  DB_FILENAME = 'test.sqlite';


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  SQLite3Connection1.DatabaseName := DB_FILENAME;
  SQLite3Connection1.Connected := true;

  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Add('SELECT * FROM Leute;');
  SQLQuery1.Open;

  SQLQuery2.SQL.Clear;
  SQLQuery2.SQL.Add('SELECT * FROM Orte;');
  SQLQuery2.Open;

  SQLQuery3.SQL.Clear;
  SQLQuery3.SQL.Add('SELECT');
  SQLQuery3.SQL.Add('Leute.Name AS Personenname, Orte.CityName as Ortschaft');
  SQLQuery3.SQL.Add('FROM');
  SQLQuery3.SQL.Add('Leute INNER JOIN Orte ON Orte.ID = Leute.City');
  SQLQuery3.SQL.Add('WHERE Leute.City = :id;');
  SQLQuery3.Open;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  SQLQuery3.Close;
  SQLQuery3.Open;
end;

procedure TForm1.SQLQuery3BeforeOpen(DataSet: TDataSet);
begin
  SQLQuery3.Params.ParamByName('id').AsInteger := SpinEdit1.Value;
end;

end.

